import 'package:flutter/material.dart';
import 'package:mwb/bloc_provider.dart';
import 'package:mwb_sample_blocuicontract/create_post_page_bloc.dart';

class CreatePostPage extends StatefulWidget {
  static Widget create() {
    return BlocProvider(
      bloc: CreatePostPageBloc(),
      child: CreatePostPage(),
    );
  }

  @override
  State<StatefulWidget> createState() => _CreatePostState();
}

class _CreatePostState extends State<CreatePostPage>
    implements CreatePostReceiver {
  CreatePostPageBloc? _bloc;

  @override
  void initState() {
    super.initState();
    _bloc = BlocProvider.of(context);
    _bloc?.receiver = this;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Create new post"),
      ),
      body: Container(
        padding: const EdgeInsets.all(16.0),
        child: Column(
          children: <Widget>[
            TextField(
              onChanged: (value) => _bloc?.newPostTitle = value,
              decoration: InputDecoration(hintText: "Title"),
            ),
            TextField(
              onChanged: (value) => _bloc?.newPostBody = value,
              decoration: InputDecoration(hintText: "Content"),
            ),
            ElevatedButton(
              child: Text("Create post"),
              onPressed: _bloc?.createPost,
            )
          ],
        ),
      ),
    );
  }

  @override
  void showMessage(String message) {
    ScaffoldMessenger.of(context).showSnackBar(SnackBar(
      content: Text(message),
    ));
  }
}
