import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:mwb/bloc_provider.dart';
import 'package:mwb_sample_blocuicontract/post.dart';

class CreatePostPageBloc extends BaseBloc {
  CreatePostReceiver? receiver;

  String newPostTitle = "";
  String newPostBody = "";

  @override
  void init() {}

  @override
  void dispose() {}

  /// Sends a request for a new post with current title and body to the JSON placeholder and shows the result
  Future createPost() async {
    final res = await http.post(
      Uri.parse("https://jsonplaceholder.typicode.com/posts"),
      headers: {"Content-Type": "application/json"},
      body: json.encode({
        "title": newPostTitle,
        "body": newPostBody,
        "userId": 1,
      }),
    );
    try {
      final post = Post.fromJSON(json.decode(res.body));
      receiver?.showMessage("New post created with ID ${post.id}");
    } catch (e) {
      receiver?.showMessage("An error occured");
    }
  }
}

/// Contract class for unified communication between a Bloc and it's corresponding UI
abstract class CreatePostReceiver {
  void showMessage(String message);
}
