/// Interface to create a simple lifecycle for an object, similar to widgets.
///
/// It is especially useful in cases where you need a separate lifecycle that you can control.
/// It also provides you control over cleaning up resources, for instance when you want to close
/// a database or streams.
abstract class Instantiable {
  void init();
  void dispose();
}
